Subject: bug#38228: closed (Re: [bug#38228] Fwd: [PATCH] gnu: boost: Build with python3)

From: [email-masked] (GNU bug Tracking System)
Date: Wed, 08 Jan 2020 21:12:01 +0000

Your bug report

#38228: Fwd: [PATCH] gnu: boost: Build with python3

which was filed against the guix-patches package, has been closed.

The explanation is attached below, along with your original report.
If you require more details, please reply to [email-masked].

-- 
38228: http://debbugs.gnu.org/cgi/bugreport.cgi?bug=38228
GNU Bug Tracking System
Contact [email-masked] with problems

Subject: Re: [bug#38228] Fwd: [PATCH] gnu: boost: Build with python3
From: Marius Bakke <[email-masked]>
To: [email-masked]
Cc: [email-masked]
Date: Wed, 08 Jan 2020 22:11:17 +0100
List-Id: <debbugs-submit.debbugs.gnu.org>

[email-masked] writes:

> Hello Marius,
> I apologize for taking so long: the end of the semester is near and my 
> time is a little limited.

No worries.  :-)

> I'm attaching the two patches. As you said the one that parameterizes 
> the python version of boost-with-python3 must be applied to master, the 
> other one to core-updates.

Excellent!  I went ahead and adjusted it to work with the Boost
cross-compilation changes on 'core-updates', as well as simplified it a
little:

https://git.savannah.gnu.org/cgit/guix.git/commit/?h=core-updates&id=2ac164a8107dbb07ba1ed29986859d3e936f795a

>>> The patch builds boost with python3 and parameterizes the python
>>> version, as Efraim suggested. I built it successfully on core updates.
>>> When I tried building Epour on core-updates and saw that Guix was
>>> starting to build Bash 5.0 I renounced (:D) and I built it on master
>>> with boost-with-python3 .
>> 
>> In general, working on the 'core-updates' branch requires a fairly
>> powerful computer (and lots of time), sorry about that!
>> 
>>> Libtorrent-rasterbar seems to build fine on master but some tests fail
>>> to pass and they all seem to be network related but then again this is
>>> torrent we are talking about. I didn't investigate further but I 
>>> attach
>>> the log.
>> 
>> Strange.  I suppose these tests are not run when using Boost + Python 
>> 2?
>> In any case we don't have to worry about that just yet ;-)
>
> I gave another look at Libtorrent-rasterbar and I noticed that it 
> depends directly on python2, so the answer to the failing tests could be 
> that upgrading both boost and the python version ( as was done in 
> Efraim's code that I used last time to test boost-with-python3 )  broke 
> something that a closer look to the failing tests could figure out.
>
> Right now I tested the upgraded version without problems by building the 
> following ( randomly selected) packages: innoextract, swig, libarea, 
> pbbam, cgal, openimageio. If you have a better idea of what must be 
> tested please tell me and I'll do some more tests.

Thanks for testing!  I had to adjust 'Vigra' to work with Python 3, but
it was straightforward:

https://git.savannah.gnu.org/cgit/guix.git/commit/?h=core-updates&id=a82e6faa8b993d1f3b47a8bd22c4509f7cae7ec1

>>> From 91a25fb143ad0e2e20e8ddadea0c0610849adf92 Mon Sep 17 00:00:00 2001
>>> From: Giacomo Leidi <[email-masked]>
>>> Date: Tue, 12 Nov 2019 00:24:49 +0100
>>> Subject: [PATCH] gnu: boost: Build with python3.
>>> 
>>> * gnu/packages/boost.scm (boost):
>>> [arguments]: Parameterize python version.
>>> [native-inputs]: Use python3.
>> 
>> [...]
>> 
>>>      (arguments
>>> -     `(#:tests? #f
>>> +     `(#:modules ((guix build gnu-build-system)
>>> +                  (guix build utils)
>>> +                  (srfi srfi-1))
>> 
>> If you add (guix build python-build-system) in there ...
>
> [...]
>
>>>           (replace 'configure
>>>             (lambda* (#:key inputs outputs #:allow-other-keys)
>>>               (let ((icu (assoc-ref inputs "icu4c"))
>>> +                   (python (assoc-ref inputs "python"))
>>> +                   (python-version
>>> +                    (take (string-split ,(package-version python) 
>>> #\.) 2))
>> 
>> ... then you can use (python-version (python-version python)) here and
>> below.
>
> I did add python-build-system to #:modules, but Guix kept complaining 
> that python-build-system was not importable until I added
>
> #:imported-modules ((guix build python-build-system)
>                             ,@%gnu-build-system-modules)
>
> Do you happen to have any idea of the differences from 
> #:imported-modules and #:modules? And why was using only 
> gnu-build-system possible also without adding it to #:imported-modules?

Caleb explains it very well here:

https://lists.gnu.org/archive/html/guix-devel/2019-12/msg00105.html

> Or even better: is there any kind of documentation of the arguments and 
> keywords and return values of Guix's functions? Something like this 
> https://flask.palletsprojects.com/en/1.1.x/api/ .

Unfortunately no, but documenting parts of the Guix API is being
discussed.  The procedures are typically documented in the source code
though, so 'git grep' is the best tool for now.  :-/

Subject: Fwd: [PATCH] gnu: boost: Build with python3
From: [email-masked]
To: [email-masked]
Date: Sat, 16 Nov 2019 09:04:44 +0000
List-Id: <debbugs-submit.debbugs.gnu.org>

Hello I'm opening another thread ( old one was 
http://issues.guix.gnu.org/issue/38128 ) to build boost in core-updates 
with python3. The new patch also parameterizes python versions across 
the package definition.

WDYT?

Bye,

Giacomo

-------- Original Message --------
Subject: Re: bug#38128: [PATCH] gnu: Add boost-with-python3
Date: 2019-11-12 00:06
 From: [email-masked]
To: Efraim Flashner <[email-masked]>
Cc: [email-masked], [email-masked]

On 2019-11-11 09:36, Efraim Flashner wrote:
> I'm going to re-open this one, sorry.
> 
> Can we replace the '--with-python-version=3.7' and 
> 'libboost_python37.so'
> with parameterized python variables so we don't have to bump it when we
> get a new python version?
> 
> Also, I've attached a package that I've never actually built that uses
> boost built with python3 if you want something to test it out with :)

I'm not sure how to send a patch for core-updates, I never did it so I 
attached it here. Please tell me if I should open another patch.

The patch builds boost with python3 and parameterizes the python 
version, as Efraim suggested. I built it successfully on core updates. 
When I tried building Epour on core-updates and saw that Guix was 
starting to build Bash 5.0 I renounced (:D) and I built it on master 
with boost-with-python3 .

Libtorrent-rasterbar seems to build fine on master but some tests fail 
to pass and they all seem to be network related but then again this is 
torrent we are talking about. I didn't investigate further but I attach 
the log.

I also tried boost-with-python3 with Malmo ( 
https://github.com/microsoft/malmo ) and it seemed to compile fine just 
but that package has other problems such as trying to start gradle so I 
nerver managed to actually run it.

Let me know what you think about the patch,

Bye

Giacomo

From 91a25fb143ad0e2e20e8ddadea0c0610849adf92 Mon Sep 17 00:00:00 2001
From: Giacomo Leidi <[email-masked]>
Date: Tue, 12 Nov 2019 00:24:49 +0100
Subject: [PATCH] gnu: boost: Build with python3.

* gnu/packages/boost.scm (boost):
[arguments]: Parameterize python version.
[native-inputs]: Use python3.
---
 gnu/packages/boost.scm | 41 +++++++++++++++++++++++++++++------------
 1 file changed, 29 insertions(+), 12 deletions(-)

diff --git a/gnu/packages/boost.scm b/gnu/packages/boost.scm
index a2253a9efc..389fd1fdb6 100644
--- a/gnu/packages/boost.scm
+++ b/gnu/packages/boost.scm
@@ -62,10 +62,13 @@
               ("zlib" ,zlib)))
     (native-inputs
      `(("perl" ,perl)
-       ("python" ,python-2)
+       ("python" ,python)
        ("tcsh" ,tcsh)))
     (arguments
-     `(#:tests? #f
+     `(#:modules ((guix build gnu-build-system)
+                  (guix build utils)
+                  (srfi srfi-1))
+       #:tests? #f
        #:make-flags
        (list "threading=multi" "link=shared"
 
@@ -83,6 +86,9 @@
          (replace 'configure
            (lambda* (#:key inputs outputs #:allow-other-keys)
              (let ((icu (assoc-ref inputs "icu4c"))
+                   (python (assoc-ref inputs "python"))
+                   (python-version
+                    (take (string-split ,(package-version python) #\.) 2))
                    (out (assoc-ref outputs "out")))
                (substitute* '("libs/config/configure"
                               "libs/spirit/classic/phoenix/test/runtest.sh"
@@ -94,11 +100,19 @@
                (setenv "SHELL" (which "sh"))
                (setenv "CONFIG_SHELL" (which "sh"))
 
+               (substitute* "tools/build/src/tools/python.jam"
+                 (("include/python\\$\\(version\\)")
+                  "include/python$(version)m"))
+
                (invoke "./bootstrap.sh"
                        (string-append "--prefix=" out)
-                       ;; Auto-detection looks for ICU only in traditional
-                       ;; install locations.
+                       ;; Auto-detection looks for dependencies only
+                       ;; in traditional install locations.
                        (string-append "--with-icu=" icu)
+                       (string-append "--with-python=" python "/bin/python3")
+                       (string-append "--with-python-root=" python)
+                       (string-append "--with-python-version="
+                                      (string-join python-version "."))
                        "--with-toolset=gcc"))))
          (replace 'build
            (lambda* (#:key make-flags #:allow-other-keys)
@@ -109,15 +123,18 @@
            (lambda* (#:key make-flags #:allow-other-keys)
              (apply invoke "./b2" "install" make-flags)))
          (add-after 'install 'provide-libboost_python
-           (lambda* (#:key outputs #:allow-other-keys)
-             (let ((out (assoc-ref outputs "out")))
-               ;; Boost can build support for both Python 2 and Python 3 since
-               ;; version 1.67.0, and suffixes each library with the Python
-               ;; version.  Many consumers only check for libboost_python
-               ;; however, so we provide it here as suggested in
-               ;; <https://github.com/boostorg/python/issues/203>.
+           (lambda* (#:key inputs outputs #:allow-other-keys)
+             (let* ((out (assoc-ref outputs "out"))
+                    (python (assoc-ref inputs "python"))
+                    (python-version
+                     (take (string-split ,(package-version python) #\.) 2))
+                    (libboost.so (string-append "libboost_python"
+                                                (string-join python-version "")
+                                                ".so")))
                (with-directory-excursion (string-append out "/lib")
-                 (symlink "libboost_python27.so" "libboost_python.so"))
+                 (symlink libboost.so "libboost_python.so")
+                 ;; Some packages also look for libboost_python3.so
+                 (symlink libboost.so "libboost_python3.so"))
                #t))))))
 
     (home-page "https://www.boost.org")
-- 
2.24.0